program cijfers(input,output);  {$R-}

uses crt;
const MAX=16000;
const MAXLINK=30000;

type getal=array [1..MAX] of longint;
type mlink=array [1..MAXLINK] of word;
type qq=array [1..MAX] of word;

var used: array [1..MAX] of byte;
    g: ^getal;
    startpos: ^mlink;
    q1,q2,link: ^qq;
    q3: array [1..MAX] of char;
    oplos,bestp,p,e2,e3,e4,e5,diff,best: longint;
    last,ii,i,j,k: word;
    c:char;
    killed, check6:boolean;

procedure presskey;
begin c:=readkey; if (c=#0) then c:=readkey;
end; {presskey}

procedure beep;
begin sound(400); delay(40); nosound; end;

procedure boop;
begin sound(150); delay(100); nosound; end;

procedure show(x:word);
var x1,x2: word;
begin x1:=q1^[x]; if (x1>6) then show(q1^[x]);
      x2:=q2^[x]; if (x2>6) then show(q2^[x]);
      if (x1<7) and (x2<7) and ((q3[x]='+') or (q3[x]='*')) then
        writeln(g^[x2]:23,' ',q3[x],g^[x1]:5,' =',g^[x]:5)
      else
        writeln(g^[x1]:23,' ',q3[x],g^[x2]:5,' =',g^[x]:5);
end; {show}

procedure disp;
begin writeln;
      write('        ');
      for i:=1 to 6 do write(g^[i]:8);
      writeln;
      writeln;
      writeln;
      writeln(oplos:37);
end; {disp}

procedure redjeorg;
begin killed:=false;
      ii:=1; last:=0;
      if (g^[p]<0) then begin killed:=true; exit; end;
      if (g^[p]<=MAXLINK) then ii:=startpos^[g^[p]];
      if (ii=1) then
      begin while (ii<p) and (g^[ii]<>g^[p]) do inc(ii);
            if (g^[p]<=MAXLINK) then startpos^[g^[p]]:=ii;
      end;
      while (ii<>0) and (ii<p) and not killed do
      begin last:=ii;
            if ((used[ii] and used[p])=used[ii]) then
            begin dec(p);
                  killed:=true;
            end;
            ii:=link^[ii]
      end;
      if (last>0) and not killed then begin link^[last]:=p; end;
      if (p+10=MAX) then
      begin gotoXY(1,20);
            writeln('        Array te klein');
            boop;
            check6:=true;
      end;
end; {redjeorg}

procedure redje;
begin killed:=false;
      ii:=1; last:=0;
      if (g^[p]<0) then begin killed:=true; exit; end;
      if (g^[p]<=MAXLINK) then
      begin ii:=startpos^[g^[p]];
            if (ii=0) then startpos^[g^[p]]:=p;
      end;

      if (ii>0) then
      begin if (g^[p]<=MAXLINK) then startpos^[g^[p]]:=ii;
            while (ii<>0) and (ii<p) and not killed do
            begin last:=ii;
                  if ((used[ii] and used[p])=used[ii]) then
                  begin dec(p);
                        killed:=true;
                  end;
                  ii:=link^[ii]
            end;
      end;
      if (last>0) and not killed then begin link^[last]:=p; end;
      if (p+10=MAX) then
      begin gotoXY(1,20);
            writeln('        Array te klein');
            boop;
            check6:=true;
      end;
end; {redje}

procedure good;
begin if (p=7) then
      begin for k:=1 to 6 do
            begin if (abs(oplos-g^[k])<diff) then
                  begin gotoXY(33,12);
                        writeln(g^[k]:5);
                        best:=g^[k];
                        diff:=abs(oplos-best);
                        bestp:=p;
                  end;
            end;
      end;
      if (abs(oplos-g^[p])<diff) then
      begin gotoXY(1,12);
            show(p);
            best:=g^[p];
            diff:=abs(oplos-best);
            bestp:=p;
            if check6 then inc(p);
      end;
      if check6 then dec(p) else redje;
end; {good}

procedure input;
begin for p:=1 to 6 do
      begin write('Geef Getal nr.',p,': ');
            readln(g^[p]);
            if (g^[p]=0) then exit;
            used[p]:=(1 shl (p-1));
      end;
      writeln;
      write('Geef Oplossing: ');
      readln(oplos);
      clrscr;
      p:=6;
end; {input}

procedure rand;
begin randomize;
      for p:=1 to 6 do
      begin g^[p]:=random(14)+1;
            if (g^[p]>10) then g^[p]:=(g^[p]-10)*25;
            used[p]:=(1 shl (p-1));
      end;
      oplos:=random(900)+100;
      clrscr;
      p:=6;
end; {rand}

procedure init;
begin new(g);
      new(startpos);
      new(q1);
      new(q2);
      new(link);
      fillchar(used,sizeof(used),0);
      fillchar(link^,sizeof(qq),0);
      for i:=1 to MAXLINK do startpos^[i]:=0;
      diff:=9999999;
      check6:=false;
end; {init}

procedure telop;
begin inc(p);
      used[p]:=used[i] or used[j];
      g^[p]:=g^[i]+g^[j];
      q1^[p]:=j;
      q2^[p]:=i;
      q3[p]:='+';
      good;
end; {telop}

procedure trekaf;
begin if g^[i]<g^[j] then
      begin inc(p);
            used[p]:=used[i] or used[j];
            g^[p]:=g^[j]-g^[i];
            q1^[p]:=j;
            q2^[p]:=i;
            q3[p]:='-';
            good;
      end;
      if g^[i]>g^[j] then
      begin inc(p);
            used[p]:=used[i] or used[j];
            g^[p]:=g^[i]-g^[j];
            q1^[p]:=i;
            q2^[p]:=j;
            q3[p]:='-';
            good;
      end;
end; {trekaf}

procedure verm;
begin if (g^[i]>1) and (g^[j]>1) then
      begin inc(p);
            used[p]:=used[i] or used[j];
            g^[p]:=g^[i]*g^[j];
            q1^[p]:=j;
            q2^[p]:=i;
            q3[p]:='*';
            good;
      end;
end; {verm}

procedure deel;
begin if (g^[i]<=g^[j]) and ((g^[j] mod g^[i])=0) and (g^[i]>1) then
      begin inc(p);
            used[p]:=used[i] or used[j];
            g^[p]:=g^[j] div g^[i];
            q1^[p]:=j;
            q2^[p]:=i;
            q3[p]:='/';
            good;
      end;
      if (g^[i]>g^[j]) and ((g^[i] mod g^[j])=0) and (g^[j]>1) then
      begin inc(p);
            used[p]:=used[i] or used[j];
            g^[p]:=g^[i] div g^[j];
            q1^[p]:=i;
            q2^[p]:=j;
            q3[p]:='/';
            good;
      end;
end; {deel}

procedure chk1;
begin for i:=1 to 6 do
      begin if g^[i]=oplos then
            begin writeln('Dat is nogal triviaal');
                  halt(0);
            end;
      end;
end; {chk1}

procedure chk2;   {1+1}
begin if (diff>0) then
      begin for i:=1 to 5 do
            begin for j:=i+1 to 6 do
                  begin telop;
                        trekaf;
                        verm;
                        deel;
                        if (diff=0) then break;
                  end;
            end;
       end;
end; {chk2}

procedure chk3;   {1+2}
begin  e2:=p;
       if (diff>0) then
       begin for i:=1 to 6 do
             begin for j:=7 to e2 do
                   begin if ((used[i] and used[j])=0) then
                         begin telop;
                               trekaf;
                               verm;
                               deel;
                               if (diff=0) then break;
                         end;
                   end;
             end;
       end;
end; {chk3}

procedure chk4;   {1+3}
begin  e3:=p;
       if (diff>0) then
       begin for i:=1 to 6 do
             begin for j:=e2+1 to e3 do
                   begin if ((used[i] and used[j])=0) then
                         begin telop;
                               trekaf;
                               verm;
                               deel;
                               if (diff=0) then break;
                         end;
                   end;
             end;
       end;

       if (diff>0) then
       begin for i:=7 to e2 do    {2+2}
             begin for j:=7 to e2 do
                   begin killed:=false;
                         if ((used[i] and used[j])=0) then
                         begin telop;
                               trekaf;
                               verm;
                               deel;
                               if (diff=0) then break;
                         end;
                   end;
             end;
       end;
end; {chk4}

procedure chk5;  {1+4}
begin  e4:=p;
       if (diff>0) then
       begin for i:=1 to 6 do
             begin for j:=e3+1 to e4 do
                   begin if ((used[i] and used[j])=0) then
                         begin telop;
                               trekaf;
                               verm;
                               deel;
                               if (diff=0) then break;
                         end;
                   end;
             end;
       end;

       if (diff>0) then
       begin for i:=7 to e2 do    {2+3}
             begin for j:=e2+1 to e3 do
                   begin killed:=false;
                         if ((used[i] and used[j])=0) then
                         begin telop;
                               trekaf;
                               verm;
                               deel;
                               if (diff=0) then break;
                         end;
                   end;
             end;
       end;
end; {chk5}

procedure chk6;  {1+5}
begin  e5:=p;
       check6:=true;
       if (diff>0) then
       begin for i:=1 to 6 do
             begin for j:=e4+1 to e5 do
                   begin if ((used[i] and used[j])=0) then
                         begin telop;
                               trekaf;
                               verm;
                               deel;
                               if (diff=0) then break;
                         end;
                   end;
             end;
       end;

       if (diff>0) then
       begin for i:=7 to e2 do    {2+4}
             begin for j:=e3+1 to e4 do
                   begin killed:=false;
                         if ((used[i] and used[j])=0) then
                         begin telop;
                               trekaf;
                               verm;
                               deel;
                               if (diff=0) then break;
                         end;
                   end;
             end;
       end;

       if (diff>0) then
       begin for i:=e2+1 to e3 do    {3+3}
             begin for j:=e2+1 to e3 do
                   begin killed:=false;
                         if ((used[i] and used[j])=0) then
                         begin telop;
                               trekaf;
                               verm;
                               deel;
                               if (diff=0) then break;
                         end;
                   end;
             end;
       end;
end; {chk6}

begin init;
      input;
      if (g^[1]=0) then rand;
      disp;
      chk1;
      chk2;
      chk3;
      chk4;
      chk5;
      chk6;
      if (diff=0) then beep;
      gotoXY(1,12);
      show(bestp);
      gotoXY(1,20);
      writeln('Klaar.');
end. {main}
